'Note: Excel class is at the bottom of this file
Imports System
Imports System.Web
Imports System.Web.UI.WebControls
Imports Microsoft.VisualBasic
Imports Microsoft.Office.Interop

Public Class ExcelOLEDemo
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region

    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'The Response.Write's are not good .NET coding, but it keeps this demo simple
        Response.Write("<html><body>")

        If Not Page.IsPostBack Then
            'Demo reading and writing to an excel file.
            Dim intRow, intCol As Integer

            'Create an instance of the ExcelOLE class (located at bottom half of this file)
            'You should compile the class into an assembly. Not done here to keep the demo simple.
            Dim objExcel As New ExcelOLE()

            'Open the Demo spreadsheet with error checking.
            'Pass "" to create a new spreadsheet
            Response.Write("<font face='arial'><b>Opening Demo Spreadsheet:</b> " & Server.MapPath("ExcelDemo.xls") & "<br>")
            If Not objExcel.OpenSpreadsheet(Server.MapPath("ExcelDemo.xls")) Then
               Response.Write(objExcel.ErrorText)
            Else
                'Display the Sheets found when we opened the spreadsheet
                Response.Write("<p><b>Worksheets Found:</b><br>")
                Dim intSheet As Integer
                For intSheet = 0 To objExcel.NumSheets - 1 'Sheets are referenced from 0 not 1
                    Response.Write(objExcel.Sheets(intSheet) & "<br>")
                Next

                'Open a worksheet via it's name  - with error checking
                Response.Write("<p><b>Opening worksheet:</b> 'Demo'<br>")
                If Not objExcel.OpenWorksheet("Demo") Then
                    Response.Write(objExcel.ErrorText & "<br>")
                Else
                    Response.Write("Open<br>")
                    Response.Flush()

                    'Display the Columns found when we opened the worksheet
                    Response.Write("<p><b>Columns Names and Data Found:</b><br>")
                    Response.Write("<table cellpadding='1' cellspacing='1' border='1' style='border-collapse: collapse; font-family: Arial; font-size: 10pt;' bordercolor='#111111'><tr bgcolor='#c0c0c0'>")
                    For intCol = 0 To objExcel.NumColumns - 1 'Columns are referenced from 0 not 1
                        Response.Write("<td>" & objExcel.Columns(intCol) & "</td>")
                    Next

                    'I can also skip a few rows ahead if i wish
                    'objExcel.CurrentRow = 3

                    'Display each data row via the ReadRow method
                    While objExcel.ReadRow
                        Response.Write("</tr><tr>")
                        For intCol = 0 To objExcel.NumColumns - 1
                            Response.Write("<td>" & objExcel.ColumnData(intCol) & "</td>")
                        Next
                    End While
                    Response.Write("</tr></table>")
                End If

                'Open a named space for writing via it's index - with error checking
                Response.Write("<p><b>Opening Sheet2 for updating:</b><br>")
                If Not objExcel.OpenWorksheet(objExcel.Sheets(2)) Then
                    Response.Write(objExcel.ErrorText & "<br>")
                Else
                    Response.Write("Open<br>")

                    'This is a quick way of reading and writing cells - with error checking
                    Dim strData As String
                    strData = objExcel.CellRead(2, 2)
                    If Not objExcel.CellWrite(2, 2, "I am newly inserted") Then Response.Write(objExcel.ErrorText & "<br>")

                    'Examples of a few direct functions which can be used:
                    'For a complete list of functions, (and their usage) see MS VBA Help: In Excel, Start the VB Editor (Alt-F11) then go to Help (F1)
                    With objExcel.ExcelBook.ActiveSheet
                        .Cells(2, 1).EntireRow.Insert()
                        .Cells(2, 2).EntireColumn.Insert()
                        .Cells(2, 2).Value = "I am newly inserted"
                        .Range("A1:D20").Borders.LineStyle = 1
                        .Range("A1:D20").Borders.Weight = 2
                        .Cells(1, 1).Font.Bold = False
                        .Range("A1").HorizontalAlignment = -4152
                        .Range("A1").ColumnWidth = 15
                    End With

                    'Display the Columns found when we opened the sheet
                    Response.Write("<p><b>Columns Names and Data Found:</b><br>")
                    Response.Write("<table cellpadding='1' cellspacing='1' border='1' style='border-collapse: collapse; font-family: Arial; font-size: 10pt;' bordercolor='#111111'><tr bgcolor='#c0c0c0'>")
                    For intCol = 0 To objExcel.NumColumns - 1
                        Response.Write("<td>" & objExcel.Columns(intCol) & "</td>")
                    Next
                    Response.Write("</tr>")

                    'Display the first 2 rows and 3 columns via direct access to the Excel's workbook object (ExcelBook)
                    For intRow = 2 To 3
                        Response.Write("<tr>")
                        For intCol = 1 To 3
                            Response.Write("<td>" & objExcel.ExcelBook.ActiveSheet.Cells(intRow, intCol).Value & "</td>")
                        Next
                        Response.Write("</tr>")
                    Next
                    Response.Write("</table>")
                End If

                'Save the Spreadsheet as a new workbook
                'Pass "" to save as existing file
                If objExcel.SaveSpreadsheet(Server.MapPath("ExcelDemoNew.xls")) Then
                    Response.Write("<p><b>Spreadsheet Saved as:</b> " & Server.MapPath("ExcelDemoNew.xls") & "<br>")
                Else
                    Response.Write(objExcel.ErrorText)
                End If

                'Close the Spreadsheet (destroying the object - setting it to nothing - will do this anyway)
                objExcel.CloseSpreadsheet()
                Response.Write("<p><b>Spreadsheet Closed</b><br>")

            End If 'open spreadsheet
        End If 'Postback
        Response.Write("</body></html>")

    End Sub
End Class

'************************************************************************************************************************************
' ExcelOLE.NET 1.03
' Excel File access via OLE Automation
' Written by Hunter Beanland
'
'If Excel hangs on open: For multiple users, in your workbook select Tools, Share Workbook, 
'   check/tick: Allow changes by more than one user.
'ExcelOLE.NET: You may need to setup the OLE/COM permissions: In WinXP+: Control Panel, Admin Tools, Component Services, Computers, My Computer, DCOM Config
'  or Win2000: run dcomcnfg from the command line. Then Microsoft Excel Application, Security, Customise each and add ASPNET to the read/execute/local permissions.
'For the Excel object to be recognised in Visual Studio, goto: Project, Add Reference, COM, Microsoft Excel Library 11
'If compiling manually, add a resource reference to the compiler: ..\bin\Interop.Excel.dll (assuming VS has copied it)

Public Class ExcelOLE
    Public ErrorText As String
    Public Sheets() As String
    Public Columns() As String
    Public NumSheets As Integer
    Public NumColumns As Integer
    Public ExcelBook As Excel.Workbook
    Public ExcelApp As Excel.Application
    Private ActiveRow As Integer = 1 'skip header row
    Private AbsoluteFileName As String
    Private Row() As String

    Property CurrentRow() As Integer
        Get
            Return ActiveRow
        End Get
        Set(ByVal Value As Integer)
            ActiveRow = Value
            If ActiveRow < 0 Then ActiveRow = 0
            If ActiveRow > 65536 Then ActiveRow = 65536
        End Set
    End Property

    Private Function GetWorksheets() As Boolean
        Dim WorkSheet As Excel.Worksheet
        NumSheets = 0
        For Each WorkSheet In ExcelBook.Worksheets
            'WorkSheet = CType(ExcelBook.Worksheets(NumSheets), Excel.Worksheet)
            ReDim Preserve Sheets(NumSheets)
            Sheets(NumSheets) = WorkSheet.Name
            NumSheets = NumSheets + 1
        Next
        If NumSheets = 0 Then
            ErrorText = "No named areas or worksheet tab names found"
            Return False
        End If
        Return True
    End Function

    Public Sub GetColumns()
        NumColumns = 0
        While ExcelBook.ActiveSheet.Cells(1, NumColumns + 1).Value <> String.Empty
            ReDim Preserve Columns(NumColumns)
            Columns(NumColumns) = ExcelBook.ActiveSheet.Cells(1, NumColumns + 1).Value
            NumColumns = NumColumns + 1
        End While
        If NumColumns = 0 Then
            ErrorText = "No column names found"
        End If
    End Sub

    Public Function OpenSpreadsheet(ByVal FileName As String) As Boolean
        'If Excel hangs on open: For multiple users, in your workbook select Tools, Share Workbook, 
        ' check/tick: Allow changes by more than one user.
        ExcelApp = New Excel.Application
        'ExcelApp = CreateObject("Excel.Application")
        ExcelApp.Visible = False
        ExcelApp.AlertBeforeOverwriting = False
        ExcelApp.ScreenUpdating = False
        ExcelApp.EnableAnimations = False
        ExcelApp.Interactive = False
        ExcelApp.DisplayAlerts = False
        ExcelApp.ScreenUpdating = False
        AbsoluteFileName = FileName
        Try
            If System.IO.File.Exists(FileName) Then
                ExcelBook = ExcelApp.Workbooks.Open(FileName)
            Else
                ExcelBook = ExcelApp.Workbooks.Add
            End If
            If GetWorksheets() Then
                ErrorText = String.Empty
                Return True
            Else
                ErrorText = "Can not get worksheets"
                Return False
            End If
        Catch e As Exception
            ErrorText = "File will not open - check file path, lock status and valid Excel file: " & e.Message
            Return False
        Finally
        End Try
    End Function

    Public Function OpenWorksheet(ByVal SheetName As String) As Boolean
        If SheetName <> String.Empty Then
            If IsArray(Sheets) Then
                If InStr(1, Join(Sheets), SheetName) = 0 Then
                    ErrorText = "Not valid named area or worksheet tab name"
                    Return False
                End If
            End If
            ExcelBook.Worksheets(SheetName).Activate()

        End If
        GetColumns()
        ErrorText = String.Empty
        Return True
    End Function

    Public Function CopyWorksheet(ByVal SrcSheetName As String, ByVal DstSheetName As String) As Boolean
        'Copy worksheet to new sheet
        Dim strNewSheet As String
        Dim WorkSheet As Excel.Worksheet
        If IsArray(Sheets) Then
            If InStr(Join(Sheets), SrcSheetName) = 0 Then
                ErrorText = "Source worksheet doesn't exist"
                Return False
            End If
            If InStr(Join(Sheets), DstSheetName) > 0 Then
                ErrorText = "Destination worksheet already exists"
                Return False
            End If
        End If
        With ExcelBook
            .Worksheets.Add()
            strNewSheet = "Sheet1"
            For Each WorkSheet In ExcelBook.Worksheets
                If InStr(1, WorkSheet.Name, "Sheet", 1) = 1 Then strNewSheet = WorkSheet.Name
            Next
            .Worksheets(strNewSheet).Name = DstSheetName
            .Worksheets(DstSheetName).Activate()
            .Worksheets(DstSheetName).Select()
            .Worksheets(SrcSheetName).Cells.Copy()
            .Worksheets(DstSheetName).Paste()
        End With
        ErrorText = String.Empty
        Return True
    End Function

    Public Function ReadRow() As Boolean
        Dim ColumnsIndex As Integer
        'Read a row into the array
        ActiveRow = ActiveRow + 1
        ReadRow = False
        If ActiveRow <= 65536 Then
            For ColumnsIndex = 0 To NumColumns - 1
                ReDim Preserve Row(ColumnsIndex)
                Row(ColumnsIndex) = ExcelBook.ActiveSheet.Cells(ActiveRow, ColumnsIndex + 1).Value
                If Row(ColumnsIndex) <> String.Empty Then ReadRow = True
            Next
        End If
    End Function

    Public Sub CloseWorksheet()
        'Not Required.
    End Sub

    Public Function ColumnData(ByVal ColNum As Integer) As String
        If ColNum <= NumColumns - 1 Then
            Return Row(ColNum)
        Else
            ErrorText = "Column out of bounds"
            Return String.Empty
        End If
    End Function

    Public Function CellRead(ByVal RowNum As Integer, ByVal ColNum As Integer) As String
        If RowNum > 0 And RowNum < 65537 And ColNum > 0 And ColNum < 257 Then
            ErrorText = String.Empty
            Return ExcelBook.ActiveSheet.Cells(RowNum, ColNum).Value
        Else
            ErrorText = "Row/Column out of bounds"
            Return String.Empty
        End If
    End Function

    Public Function CellWrite(ByVal RowNum As Integer, ByVal ColNum As Integer, ByVal CellValue As String) As Boolean
        If RowNum > 0 And RowNum < 65537 And ColNum > 0 And ColNum < 257 Then
            ExcelBook.ActiveSheet.Cells(RowNum, ColNum).Value = CellValue
            Return True
            ErrorText = String.Empty
        Else
            Return False
            ErrorText = "Row/Column out of bounds"
        End If
    End Function

    Public Function SaveSpreadsheet(ByVal NewFileName As String) As Boolean
        If NewFileName = String.Empty Then NewFileName = AbsoluteFileName
        Try
            ExcelBook.SaveAs(NewFileName)
            'Save - sometimes fails?? - Use Save As
            'ExcelBook.Save()
        Catch e As Exception
            ErrorText = "Save Failed. Check write protection and file locks: " & e.Message
        End Try
        If ExcelBook.Saved Then
            ErrorText = String.Empty
            Return True
        Else
            ErrorText = "Save Failed. Check write protection and file locks."
            Return False
        End If
    End Function

    Public Sub CloseSpreadsheet()
        'Close and destroy completely
        Try
            ExcelBook.Saved = True
            ExcelBook.Close()
            System.Runtime.InteropServices.Marshal.ReleaseComObject(ExcelBook)
            ExcelBook = Nothing
        Catch
        End Try
        Try
            ExcelApp.Application.Quit()
            System.Runtime.InteropServices.Marshal.ReleaseComObject(ExcelApp)
            ExcelApp = Nothing
        Catch
        End Try
        'GC.Collect()
    End Sub

    Protected Overloads Overrides Sub Finalize()
        'Make sure it is closed (to release file locks and resources)
        CloseSpreadsheet()
    End Sub
End Class